<template>
  <v-card
    id="search-card"
    flat
  >
    <div class="bg-img flex-shrink-1 flex-grow-0">
      <v-img
        id="search-bg"
        src="../assets/img/search-bg.png"
        contain
        height="275"
      />
    </div>
    <v-card-title class="font-weight-bold mb-3">
      Узнайте, как национальные проекты могут сделать вашу жизнь лучше
    </v-card-title>

    <v-card-text class="pl-0 pr-0">
      <v-autocomplete
        solo
        rounded
        flat
        no-filter
        hide-details
        clearable
        return-object
        v-model="select"
        :items="items"
        :search-input.sync="search"
        id="search-input"
        background-color="#F5F7FB"
        placeholder="Введите ваш адрес"
        append-icon="mdi-magnify"
        @click:append="find()"
        class="mb-2"
      ></v-autocomplete>

      <div class="d-none d-sm-flex flex-wrap mb-2">
        <v-btn text color="white" class="text-none" to="/projects">
          Все полезные дела
        </v-btn>
        <v-btn text color="white" class="text-none">
          Вопросы и ответы
        </v-btn>
        <v-btn text color="white" class="text-none">
          Документы
        </v-btn>
        <v-btn text color="white" class="text-none">
          О проекте
        </v-btn>
      </div>

    </v-card-text>
  </v-card>
</template>
<script>
  export default {
    name: 'SearchField',
    data: function() {
      return {
        select: null,
        search: null,
        items: ['Адрес не найден'],
      };
    },
    watch: {
      select(value) {
        this.$emit('input', value ? value.value : null);
        this.find(value);
      },
      search(query) {
        if (query && (!this.select || this.select.text !== query)) {
          this.querySearch(query);
        }
      },
    },
    methods: {
      find: function(query) {
        query = query || this.search;
        this.$router.push({path: `/search?address=${query}`});
      },
      querySearch: async function querySearch() {
        // eslint-disable-next-line
        const result = await ymaps.suggest(
          this.search,
          {
            provider: {
              suggest:((request) => {
                // eslint-disable-next-line
                return ymaps.suggest(`${process.env.VUE_APP_SEARCH}` + ", " + request);
              })
            },
            results: 5,
          });
        const places = [];
        result.forEach(el => {
          places.push(el.value);
        });
        this.items = places;
      },
    },
  };
</script>

<style scoped>
  #search-card {
    z-index: 0;
  }

  #search-card:before {
    content: "";
    position: absolute;
    display: block;
    left: -24px;
    width: 100vw;
    height: 100%;
    background: linear-gradient(253.34deg, #FFFFFF -5.84%, rgba(255, 255, 255, 0) 52.26%), linear-gradient(109.9deg, rgba(1, 12, 29, 0.2) 34%, rgba(255, 255, 255, 0) 75.15%), #44578C;
  }

  #search-card .v-card__title {
    padding: 80px 0 0 0;
    font-size: 1.2rem;
  }

  #search-card .v-card__title,
  #search-card .v-card__text {
    line-height: 1.5rem;
    color: white;
    position: relative;
    z-index: 1;
  }

  .v-text-field__slot input::placeholder {
    color: #98A7B6;
  }

  .bg-img {
    position: absolute;
    right: -20px;
  }

  @media screen and (max-width: 600px) {
    #search-card .v-card__title {
      padding-top: 30px;
      padding-bottom: 10px;
    }

    #search-bg {
      height: 160px !important;
      width: 160px;
    }
  }
</style>
